Index: /palm/trunk/SOURCE/prognostic_equations.f90
===================================================================
--- /palm/trunk/SOURCE/prognostic_equations.f90	(revision 2231)
+++ /palm/trunk/SOURCE/prognostic_equations.f90	(revision 2232)
@@ -20,6 +20,7 @@
 ! Current revisions:
 ! ------------------
+! Adjutst to new surface-type structure. Remove call for usm_wall_heat_flux, 
+! which is realized directly in diffusion_s now.
 ! 
-!
 ! Former revisions:
 ! -----------------
@@ -225,9 +226,8 @@
                flux_s_pt, flux_s_q, flux_s_qr, flux_s_s, flux_s_sa, flux_l_e,  &
                flux_l_nr, flux_l_pt, flux_l_q, flux_l_qr, flux_l_s, flux_l_sa, &
-               nr, nr_p, nrsws, nrswst, pt, ptdf_x, ptdf_y, pt_init, pt_p,     &
-               prho, q, q_init, q_p, qsws, qswst, qr, qr_p, qrsws, qrswst, rdf,&
-               rdf_sc, ref_state, rho_ocean, s, s_init, s_p, sa, sa_init, sa_p,      &
-               saswsb, saswst, shf, ssws, sswst, tend,                         &
-               te_m, tnr_m, tpt_m, tq_m, tqr_m, ts_m, tsa_m, tswst, tu_m, tv_m,&
+               nr, nr_p, pt, ptdf_x, ptdf_y, pt_init, pt_p,                    &
+               prho, q, q_init, q_p, qr, qr_p, rdf,                            &
+               rdf_sc, ref_state, rho_ocean, s, s_init, s_p, sa, sa_init, sa_p,&
+               tend, te_m, tnr_m, tpt_m, tq_m, tqr_m, ts_m, tsa_m, tu_m, tv_m, &
                tw_m, u, ug, u_init, u_p, v, vg, vpt, v_init, v_p, w, w_p
 
@@ -243,8 +243,6 @@
                prho_reference, pt_reference, pt_reference, pt_reference,       &
                scalar_advec, scalar_advec, simulated_time, sloping_surface,    &
-               timestep_scheme, tsc, urban_surface, use_subsidence_tendencies, &
-               use_upstream_for_tke, wall_heatflux,                            &
-               wall_nrflux, wall_qflux, wall_qflux, wall_qflux, wall_qrflux,   &
-               wall_salinityflux, wall_sflux, ws_scheme_mom, ws_scheme_sca
+               timestep_scheme, tsc, use_subsidence_tendencies,                &
+               use_upstream_for_tke, ws_scheme_mom, ws_scheme_sca
 
     USE cpulog,                                                                &
@@ -255,6 +253,6 @@
 
     USE indices,                                                               &
-        ONLY:  nxl, nxlg, nxlu, nxr, nxrg, nyn, nyng, nys, nysg, nysv,         &
-               nzb_s_inner, nzb_u_inner, nzb_v_inner, nzb_w_inner, nzt
+        ONLY:  nxl, nxlg, nxlu, nxr, nxrg, nyn, nyng, nys, nysg, nysv, nzb,    &
+               nzt, wall_flags_0
 
     USE advec_ws,                                                              &
@@ -339,9 +337,10 @@
         ONLY:  subsidence
 
-    USE urban_surface_mod,                                                     &
-        ONLY:  usm_wall_heat_flux
-
     USE user_actions_mod,                                                      &
         ONLY:  user_actions
+
+    USE surface_mod,                                                           &
+        ONLY :  surf_def_h, surf_def_v, surf_lsm_h, surf_lsm_v, surf_usm_h,    &
+                surf_usm_v 
 
     USE wind_turbine_model_mod,                                                &
@@ -404,4 +403,6 @@
        !$OMP PARALLEL private (i,j)
        !$OMP DO
+!$OMP PARALLEL PRIVATE (i, j)
+!$OMP DO
        DO  i = nxlg, nxrg
           DO  j = nysg, nyng
@@ -410,4 +411,5 @@
        ENDDO
        !$OMP END PARALLEL
+!$OMP END PARALLEL
     ENDIF
 
@@ -474,8 +476,14 @@
 !
 !--          Prognostic equation for u-velocity component
-             DO  k = nzb_u_inner(j,i)+1, nzt
-                u_p(k,j,i) = u(k,j,i) + dt_3d * ( tsc(2) * tend(k,j,i) +       &
-                                                  tsc(3) * tu_m(k,j,i) )       &
-                                      - tsc(5) * rdf(k) * ( u(k,j,i) - u_init(k) )
+             DO  k = nzb+1, nzt
+
+                u_p(k,j,i) = u(k,j,i) + ( dt_3d *                               &
+                                            ( tsc(2) * tend(k,j,i) +            &
+                                              tsc(3) * tu_m(k,j,i) )            &
+                                            - tsc(5) * rdf(k)                   &
+                                                     * ( u(k,j,i) - u_init(k) ) &
+                                        ) * MERGE( 1.0_wp, 0.0_wp,              &
+                                                   BTEST( wall_flags_0(k,j,i), 1 )&
+                                                 )
              ENDDO
 
@@ -484,11 +492,12 @@
              IF ( timestep_scheme(1:5) == 'runge' )  THEN
                 IF ( intermediate_timestep_count == 1 )  THEN
-                   DO  k = nzb_u_inner(j,i)+1, nzt
+                   DO  k = nzb+1, nzt
                       tu_m(k,j,i) = tend(k,j,i)
                    ENDDO
                 ELSEIF ( intermediate_timestep_count < &
                          intermediate_timestep_count_max )  THEN
-                   DO  k = nzb_u_inner(j,i)+1, nzt
-                      tu_m(k,j,i) = -9.5625_wp * tend(k,j,i) + 5.3125_wp * tu_m(k,j,i)
+                   DO  k = nzb+1, nzt
+                      tu_m(k,j,i) =   -9.5625_wp * tend(k,j,i)                &
+                                     + 5.3125_wp * tu_m(k,j,i)
                    ENDDO
                 ENDIF
@@ -537,8 +546,13 @@
 !
 !--          Prognostic equation for v-velocity component
-             DO  k = nzb_v_inner(j,i)+1, nzt
-                v_p(k,j,i) = v(k,j,i) + dt_3d * ( tsc(2) * tend(k,j,i) +       &
-                                                  tsc(3) * tv_m(k,j,i) )       &
-                                      - tsc(5) * rdf(k) * ( v(k,j,i) - v_init(k) )
+             DO  k = nzb+1, nzt
+                v_p(k,j,i) = v(k,j,i) + ( dt_3d *                              &
+                                            ( tsc(2) * tend(k,j,i) +           &
+                                              tsc(3) * tv_m(k,j,i) )           &
+                                            - tsc(5) * rdf(k)                  &
+                                                     * ( v(k,j,i) - v_init(k) )&
+                                        ) * MERGE( 1.0_wp, 0.0_wp,             &
+                                                   BTEST( wall_flags_0(k,j,i), 2 )&
+                                                 )
              ENDDO
 
@@ -547,11 +561,12 @@
              IF ( timestep_scheme(1:5) == 'runge' )  THEN
                 IF ( intermediate_timestep_count == 1 )  THEN
-                   DO  k = nzb_v_inner(j,i)+1, nzt
+                   DO  k = nzb+1, nzt
                       tv_m(k,j,i) = tend(k,j,i)
                    ENDDO
                 ELSEIF ( intermediate_timestep_count < &
                          intermediate_timestep_count_max )  THEN
-                   DO  k = nzb_v_inner(j,i)+1, nzt
-                      tv_m(k,j,i) = -9.5625_wp * tend(k,j,i) + 5.3125_wp * tv_m(k,j,i)
+                   DO  k = nzb+1, nzt
+                      tv_m(k,j,i) =   -9.5625_wp * tend(k,j,i)                 &
+                                     + 5.3125_wp * tv_m(k,j,i)
                    ENDDO
                 ENDIF
@@ -596,11 +611,14 @@
 
           CALL user_actions( i, j, 'w-tendency' )
-
 !
 !--       Prognostic equation for w-velocity component
-          DO  k = nzb_w_inner(j,i)+1, nzt-1
-             w_p(k,j,i) = w(k,j,i) + dt_3d * ( tsc(2) * tend(k,j,i) +          &
+          DO  k = nzb+1, nzt-1
+             w_p(k,j,i) = w(k,j,i) + ( dt_3d *                                 &
+                                             ( tsc(2) * tend(k,j,i) +          &
                                                tsc(3) * tw_m(k,j,i) )          &
-                                   - tsc(5) * rdf(k) * w(k,j,i)
+                                             - tsc(5) * rdf(k) * w(k,j,i)      &
+                                     ) * MERGE( 1.0_wp, 0.0_wp,                &
+                                                BTEST( wall_flags_0(k,j,i), 3 )&
+                                              )
           ENDDO
 
@@ -609,11 +627,12 @@
           IF ( timestep_scheme(1:5) == 'runge' )  THEN
              IF ( intermediate_timestep_count == 1 )  THEN
-                DO  k = nzb_w_inner(j,i)+1, nzt-1
+                DO  k = nzb+1, nzt-1
                    tw_m(k,j,i) = tend(k,j,i)
                 ENDDO
              ELSEIF ( intermediate_timestep_count < &
                       intermediate_timestep_count_max )  THEN
-                DO  k = nzb_w_inner(j,i)+1, nzt-1
-                   tw_m(k,j,i) = -9.5625_wp * tend(k,j,i) + 5.3125_wp * tw_m(k,j,i)
+                DO  k = nzb+1, nzt-1
+                   tw_m(k,j,i) =   -9.5625_wp * tend(k,j,i)                    &
+                                  + 5.3125_wp * tw_m(k,j,i)
                 ENDDO
              ENDIF
@@ -628,5 +647,5 @@
              IF ( timestep_scheme(1:5) == 'runge' )  THEN
                    IF ( ws_scheme_sca )  THEN
-                      CALL advec_s_ws( i, j, pt, 'pt', flux_s_pt, diss_s_pt, &
+                      CALL advec_s_ws( i, j, pt, 'pt', flux_s_pt, diss_s_pt,   &
                                        flux_l_pt, diss_l_pt, i_omp_start, tn )
                    ELSE
@@ -636,12 +655,14 @@
                 CALL advec_s_up( i, j, pt )
              ENDIF
-             CALL diffusion_s( i, j, pt, shf, tswst, wall_heatflux )
-
-!
-!--          Tendency pt from wall heat flux from urban surface
-             IF ( urban_surface )  THEN
-                CALL usm_wall_heat_flux( i, j )
-             ENDIF
-
+             CALL diffusion_s( i, j, pt,                                       &
+                               surf_def_h(0)%shf, surf_def_h(1)%shf,           &
+                               surf_def_h(2)%shf,                              &
+                               surf_lsm_h%shf,    surf_usm_h%shf,              &
+                               surf_def_v(0)%shf, surf_def_v(1)%shf,           &
+                               surf_def_v(2)%shf, surf_def_v(3)%shf,           &
+                               surf_lsm_v(0)%shf, surf_lsm_v(1)%shf,           &
+                               surf_lsm_v(2)%shf, surf_lsm_v(3)%shf,           &
+                               surf_usm_v(0)%shf, surf_usm_v(1)%shf,           &
+                               surf_usm_v(2)%shf, surf_usm_v(3)%shf )
 !
 !--          If required compute heating/cooling due to long wave radiation
@@ -683,12 +704,18 @@
 
              CALL user_actions( i, j, 'pt-tendency' )
-
 !
 !--          Prognostic equation for potential temperature
-             DO  k = nzb_s_inner(j,i)+1, nzt
-                pt_p(k,j,i) = pt(k,j,i) + dt_3d * ( tsc(2) * tend(k,j,i) +     &
+             DO  k = nzb+1, nzt
+                pt_p(k,j,i) = pt(k,j,i) + ( dt_3d *                            &
+                                                  ( tsc(2) * tend(k,j,i) +     &
                                                     tsc(3) * tpt_m(k,j,i) )    &
-                                        - tsc(5) * ( pt(k,j,i) - pt_init(k) ) *&
-                                          ( rdf_sc(k) + ptdf_x(i) + ptdf_y(j) )
+                                                  - tsc(5)                     &
+                                                  * ( pt(k,j,i) - pt_init(k) ) &
+                                                  * ( rdf_sc(k) + ptdf_x(i)    &
+                                                                + ptdf_y(j) )  &
+                                          )                                    &
+                                       * MERGE( 1.0_wp, 0.0_wp,                &
+                                                BTEST( wall_flags_0(k,j,i), 0 )&
+                                              )
              ENDDO
 
@@ -697,12 +724,12 @@
              IF ( timestep_scheme(1:5) == 'runge' )  THEN
                 IF ( intermediate_timestep_count == 1 )  THEN
-                   DO  k = nzb_s_inner(j,i)+1, nzt
+                   DO  k = nzb+1, nzt
                       tpt_m(k,j,i) = tend(k,j,i)
                    ENDDO
                 ELSEIF ( intermediate_timestep_count < &
                          intermediate_timestep_count_max )  THEN
-                   DO  k = nzb_s_inner(j,i)+1, nzt
-                      tpt_m(k,j,i) = -9.5625_wp * tend(k,j,i) + &
-                                      5.3125_wp * tpt_m(k,j,i)
+                   DO  k = nzb+1, nzt
+                      tpt_m(k,j,i) =   -9.5625_wp * tend(k,j,i) +              &
+                                        5.3125_wp * tpt_m(k,j,i)
                    ENDDO
                 ENDIF
@@ -729,5 +756,14 @@
                 CALL advec_s_up( i, j, sa )
              ENDIF
-             CALL diffusion_s( i, j, sa, saswsb, saswst, wall_salinityflux )
+             CALL diffusion_s( i, j, sa,                                       &
+                               surf_def_h(0)%sasws, surf_def_h(1)%sasws,       &
+                               surf_def_h(2)%sasws,                            &
+                               surf_lsm_h%sasws,    surf_usm_h%sasws,          & 
+                               surf_def_v(0)%sasws, surf_def_v(1)%sasws,       &
+                               surf_def_v(2)%sasws, surf_def_v(3)%sasws,       &
+                               surf_lsm_v(0)%sasws, surf_lsm_v(1)%sasws,       &
+                               surf_lsm_v(2)%sasws, surf_lsm_v(3)%sasws,       &
+                               surf_usm_v(0)%sasws, surf_usm_v(1)%sasws,       &
+                               surf_usm_v(2)%sasws, surf_usm_v(3)%sasws )
 
              CALL user_actions( i, j, 'sa-tendency' )
@@ -735,9 +771,13 @@
 !
 !--          Prognostic equation for salinity
-             DO  k = nzb_s_inner(j,i)+1, nzt
-                sa_p(k,j,i) = sa(k,j,i) + dt_3d * ( tsc(2) * tend(k,j,i) +     &
+             DO  k = nzb+1, nzt
+                sa_p(k,j,i) = sa(k,j,i) + ( dt_3d *                            &
+                                                  ( tsc(2) * tend(k,j,i) +     &
                                                     tsc(3) * tsa_m(k,j,i) )    &
-                                        - tsc(5) * rdf_sc(k) *                 &
-                                          ( sa(k,j,i) - sa_init(k) )
+                                                  - tsc(5) * rdf_sc(k)         &
+                                                   * ( sa(k,j,i) - sa_init(k) )&
+                                          ) * MERGE( 1.0_wp, 0.0_wp,           &
+                                                BTEST( wall_flags_0(k,j,i), 0 )&
+                                                   )
                 IF ( sa_p(k,j,i) < 0.0_wp )  sa_p(k,j,i) = 0.1_wp * sa(k,j,i)
              ENDDO
@@ -747,13 +787,13 @@
              IF ( timestep_scheme(1:5) == 'runge' )  THEN
                 IF ( intermediate_timestep_count == 1 )  THEN
-                   DO  k = nzb_s_inner(j,i)+1, nzt
+                   DO  k = nzb+1, nzt
                       tsa_m(k,j,i) = tend(k,j,i)
                    ENDDO
                 ELSEIF ( intermediate_timestep_count < &
                          intermediate_timestep_count_max )  THEN
-                   DO  k = nzb_s_inner(j,i)+1, nzt
-                      tsa_m(k,j,i) = -9.5625_wp * tend(k,j,i) + &
-                                      5.3125_wp * tsa_m(k,j,i)
-                   ENDDO
+                   DO  k = nzb+1, nzt
+                      tsa_m(k,j,i) =   -9.5625_wp * tend(k,j,i) +              &
+                                        5.3125_wp * tsa_m(k,j,i)
+                   ENDDO  
                 ENDIF
              ENDIF
@@ -783,5 +823,14 @@
                 CALL advec_s_up( i, j, q )
              ENDIF
-             CALL diffusion_s( i, j, q, qsws, qswst, wall_qflux )
+             CALL diffusion_s( i, j, q,                                        &
+                               surf_def_h(0)%qsws, surf_def_h(1)%qsws,         &
+                               surf_def_h(2)%qsws,                             &
+                               surf_lsm_h%qsws,    surf_usm_h%qsws,            &
+                               surf_def_v(0)%qsws, surf_def_v(1)%qsws,         &
+                               surf_def_v(2)%qsws, surf_def_v(3)%qsws,         &
+                               surf_lsm_v(0)%qsws, surf_lsm_v(1)%qsws,         &
+                               surf_lsm_v(2)%qsws, surf_lsm_v(3)%qsws,         &
+                               surf_usm_v(0)%qsws, surf_usm_v(1)%qsws,         &
+                               surf_usm_v(2)%qsws, surf_usm_v(3)%qsws )
 
 !
@@ -810,9 +859,14 @@
 !
 !--          Prognostic equation for total water content / scalar
-             DO  k = nzb_s_inner(j,i)+1, nzt
-                q_p(k,j,i) = q(k,j,i) + dt_3d * ( tsc(2) * tend(k,j,i) +       &
+             DO  k = nzb+1, nzt
+                q_p(k,j,i) = q(k,j,i) + ( dt_3d *                              &
+                                                ( tsc(2) * tend(k,j,i) +       &
                                                   tsc(3) * tq_m(k,j,i) )       &
-                                      - tsc(5) * rdf_sc(k) *                   &
-                                        ( q(k,j,i) - q_init(k) )
+                                                - tsc(5) * rdf_sc(k) *         &
+                                                      ( q(k,j,i) - q_init(k) ) &
+                                        )                                      &
+                                       * MERGE( 1.0_wp, 0.0_wp,                &
+                                                BTEST( wall_flags_0(k,j,i), 0 )&
+                                              )                
                 IF ( q_p(k,j,i) < 0.0_wp )  q_p(k,j,i) = 0.1_wp * q(k,j,i)
              ENDDO
@@ -822,12 +876,12 @@
              IF ( timestep_scheme(1:5) == 'runge' )  THEN
                 IF ( intermediate_timestep_count == 1 )  THEN
-                   DO  k = nzb_s_inner(j,i)+1, nzt
+                   DO  k = nzb+1, nzt
                       tq_m(k,j,i) = tend(k,j,i)
                    ENDDO
                 ELSEIF ( intermediate_timestep_count < &
                          intermediate_timestep_count_max )  THEN
-                   DO  k = nzb_s_inner(j,i)+1, nzt
-                      tq_m(k,j,i) = -9.5625_wp * tend(k,j,i) + &
-                                     5.3125_wp * tq_m(k,j,i)
+                   DO  k = nzb+1, nzt
+                      tq_m(k,j,i) =   -9.5625_wp * tend(k,j,i) +               &
+                                       5.3125_wp * tq_m(k,j,i)
                    ENDDO
                 ENDIF
@@ -853,12 +907,27 @@
                    CALL advec_s_up( i, j, qr )
                 ENDIF
-                CALL diffusion_s( i, j, qr, qrsws, qrswst, wall_qrflux )
+                CALL diffusion_s( i, j, qr,                                   &
+                                  surf_def_h(0)%qrsws, surf_def_h(1)%qrsws,   &
+                                  surf_def_h(2)%qrsws,                        &
+                                  surf_lsm_h%qrsws,    surf_usm_h%qrsws,      &  
+                                  surf_def_v(0)%qrsws, surf_def_v(1)%qrsws,   &
+                                  surf_def_v(2)%qrsws, surf_def_v(3)%qrsws,   &
+                                  surf_lsm_v(0)%qrsws, surf_lsm_v(1)%qrsws,   &
+                                  surf_lsm_v(2)%qrsws, surf_lsm_v(3)%qrsws,   &
+                                  surf_usm_v(0)%qrsws, surf_usm_v(1)%qrsws,   &
+                                  surf_usm_v(2)%qrsws, surf_usm_v(3)%qrsws )
 
 !
 !--             Prognostic equation for rain water content
-                DO  k = nzb_s_inner(j,i)+1, nzt
-                   qr_p(k,j,i) = qr(k,j,i) + dt_3d * ( tsc(2) * tend(k,j,i) +  &
-                                                       tsc(3) * tqr_m(k,j,i) ) &
-                                           - tsc(5) * rdf_sc(k) * qr(k,j,i)
+                DO  k = nzb+1, nzt
+                   qr_p(k,j,i) = qr(k,j,i) + ( dt_3d *                         &
+                                                      ( tsc(2) * tend(k,j,i) + &
+                                                        tsc(3) * tqr_m(k,j,i) )&
+                                                      - tsc(5) * rdf_sc(k)     &
+                                                               * qr(k,j,i)     &
+                                             )                                 &
+                                       * MERGE( 1.0_wp, 0.0_wp,                &
+                                                BTEST( wall_flags_0(k,j,i), 0 )&
+                                              ) 
                    IF ( qr_p(k,j,i) < 0.0_wp )  qr_p(k,j,i) = 0.0_wp
                 ENDDO
@@ -867,12 +936,12 @@
                 IF ( timestep_scheme(1:5) == 'runge' )  THEN
                    IF ( intermediate_timestep_count == 1 )  THEN
-                      DO  k = nzb_s_inner(j,i)+1, nzt
+                      DO  k = nzb+1, nzt
                          tqr_m(k,j,i) = tend(k,j,i)
                       ENDDO
                    ELSEIF ( intermediate_timestep_count < &
                             intermediate_timestep_count_max )  THEN
-                      DO  k = nzb_s_inner(j,i)+1, nzt
-                         tqr_m(k,j,i) = -9.5625_wp * tend(k,j,i) + &
-                                        5.3125_wp * tqr_m(k,j,i)
+                      DO  k = nzb+1, nzt
+                         tqr_m(k,j,i) =   -9.5625_wp * tend(k,j,i) +           &
+                                           5.3125_wp * tqr_m(k,j,i)
                       ENDDO
                    ENDIF
@@ -893,12 +962,27 @@
                    CALL advec_s_up( i, j, nr )
                 ENDIF
-                CALL diffusion_s( i, j, nr, nrsws, nrswst, wall_nrflux )
+                CALL diffusion_s( i, j, nr,                                    &
+                                  surf_def_h(0)%nrsws, surf_def_h(1)%nrsws,    &
+                                  surf_def_h(2)%nrsws,                         &
+                                  surf_lsm_h%nrsws,    surf_usm_h%nrsws,       &
+                                  surf_def_v(0)%nrsws, surf_def_v(1)%nrsws,    &
+                                  surf_def_v(2)%nrsws, surf_def_v(3)%nrsws,    &
+                                  surf_lsm_v(0)%nrsws, surf_lsm_v(1)%nrsws,    &
+                                  surf_lsm_v(2)%nrsws, surf_lsm_v(3)%nrsws,    &
+                                  surf_usm_v(0)%nrsws, surf_usm_v(1)%nrsws,    &
+                                  surf_usm_v(2)%nrsws, surf_usm_v(3)%nrsws )
 
 !
 !--             Prognostic equation for rain drop concentration
-                DO  k = nzb_s_inner(j,i)+1, nzt
-                   nr_p(k,j,i) = nr(k,j,i) + dt_3d * ( tsc(2) * tend(k,j,i) +  &
-                                                       tsc(3) * tnr_m(k,j,i) ) &
-                                           - tsc(5) * rdf_sc(k) * nr(k,j,i)
+                DO  k = nzb+1, nzt
+                   nr_p(k,j,i) = nr(k,j,i) + ( dt_3d *                         &
+                                                      ( tsc(2) * tend(k,j,i) + &
+                                                        tsc(3) * tnr_m(k,j,i) )&
+                                                      - tsc(5) * rdf_sc(k)     &
+                                                               * nr(k,j,i)     &
+                                             )                                 &
+                                       * MERGE( 1.0_wp, 0.0_wp,                &
+                                                BTEST( wall_flags_0(k,j,i), 0 )&
+                                              )
                    IF ( nr_p(k,j,i) < 0.0_wp )  nr_p(k,j,i) = 0.0_wp
                 ENDDO
@@ -907,12 +991,12 @@
                 IF ( timestep_scheme(1:5) == 'runge' )  THEN
                    IF ( intermediate_timestep_count == 1 )  THEN
-                      DO  k = nzb_s_inner(j,i)+1, nzt
+                      DO  k = nzb+1, nzt
                          tnr_m(k,j,i) = tend(k,j,i)
                       ENDDO
                    ELSEIF ( intermediate_timestep_count < &
                             intermediate_timestep_count_max )  THEN
-                      DO  k = nzb_s_inner(j,i)+1, nzt
-                         tnr_m(k,j,i) = -9.5625_wp * tend(k,j,i) + &
-                                        5.3125_wp * tnr_m(k,j,i)
+                      DO  k = nzb+1, nzt
+                         tnr_m(k,j,i) =   -9.5625_wp * tend(k,j,i) +           &
+                                           5.3125_wp * tnr_m(k,j,i)
                       ENDDO
                    ENDIF
@@ -940,5 +1024,14 @@
                 CALL advec_s_up( i, j, s )
              ENDIF
-             CALL diffusion_s( i, j, s, ssws, sswst, wall_sflux )
+             CALL diffusion_s( i, j, s,                                        &
+                               surf_def_h(0)%ssws, surf_def_h(1)%ssws,         &
+                               surf_def_h(2)%ssws,                             &
+                               surf_lsm_h%ssws,    surf_usm_h%ssws,            &
+                               surf_def_v(0)%ssws, surf_def_v(1)%ssws,         &
+                               surf_def_v(2)%ssws, surf_def_v(3)%ssws,         &
+                               surf_lsm_v(0)%ssws, surf_lsm_v(1)%ssws,         &
+                               surf_lsm_v(2)%ssws, surf_lsm_v(3)%ssws,         &
+                               surf_usm_v(0)%ssws, surf_usm_v(1)%ssws,         &
+                               surf_usm_v(2)%ssws, surf_usm_v(3)%ssws )
 
 !
@@ -971,9 +1064,14 @@
 !
 !--          Prognostic equation for scalar
-             DO  k = nzb_s_inner(j,i)+1, nzt
-                s_p(k,j,i) = s(k,j,i) + dt_3d * ( tsc(2) * tend(k,j,i) +       &
-                                                  tsc(3) * ts_m(k,j,i) )       &
-                                      - tsc(5) * rdf_sc(k) *                   &
-                                        ( s(k,j,i) - s_init(k) )
+             DO  k = nzb+1, nzt
+                s_p(k,j,i) = s(k,j,i) + (  dt_3d *                             &
+                                            ( tsc(2) * tend(k,j,i) +           &
+                                              tsc(3) * ts_m(k,j,i) )           &
+                                            - tsc(5) * rdf_sc(k)               &
+                                                     * ( s(k,j,i) - s_init(k) )&
+                                        )                                      &
+                                       * MERGE( 1.0_wp, 0.0_wp,                &
+                                                BTEST( wall_flags_0(k,j,i), 0 )&
+                                              )
                 IF ( s_p(k,j,i) < 0.0_wp )  s_p(k,j,i) = 0.1_wp * s(k,j,i)
              ENDDO
@@ -983,12 +1081,12 @@
              IF ( timestep_scheme(1:5) == 'runge' )  THEN
                 IF ( intermediate_timestep_count == 1 )  THEN
-                   DO  k = nzb_s_inner(j,i)+1, nzt
+                   DO  k = nzb+1, nzt
                       ts_m(k,j,i) = tend(k,j,i)
                    ENDDO
                 ELSEIF ( intermediate_timestep_count < &
                          intermediate_timestep_count_max )  THEN
-                   DO  k = nzb_s_inner(j,i)+1, nzt
-                      ts_m(k,j,i) = -9.5625_wp * tend(k,j,i) + &
-                                     5.3125_wp * ts_m(k,j,i)
+                   DO  k = nzb+1, nzt
+                      ts_m(k,j,i) =   -9.5625_wp * tend(k,j,i) +               &
+                                       5.3125_wp * ts_m(k,j,i)
                    ENDDO
                 ENDIF
@@ -1037,7 +1135,12 @@
 !--          reasons in the course of the integration. In such cases the old
 !--          TKE value is reduced by 90%.
-             DO  k = nzb_s_inner(j,i)+1, nzt
-                e_p(k,j,i) = e(k,j,i) + dt_3d * ( tsc(2) * tend(k,j,i) +       &
-                                                  tsc(3) * te_m(k,j,i) )
+             DO  k = nzb+1, nzt
+                e_p(k,j,i) = e(k,j,i) + ( dt_3d *                              &
+                                                ( tsc(2) * tend(k,j,i) +       &
+                                                  tsc(3) * te_m(k,j,i) )       &
+                                        )                                      &
+                                       * MERGE( 1.0_wp, 0.0_wp,                &
+                                                BTEST( wall_flags_0(k,j,i), 0 )&
+                                              )
                 IF ( e_p(k,j,i) < 0.0_wp )  e_p(k,j,i) = 0.1_wp * e(k,j,i)
              ENDDO
@@ -1047,12 +1150,12 @@
              IF ( timestep_scheme(1:5) == 'runge' )  THEN
                 IF ( intermediate_timestep_count == 1 )  THEN
-                   DO  k = nzb_s_inner(j,i)+1, nzt
+                   DO  k = nzb+1, nzt
                       te_m(k,j,i) = tend(k,j,i)
                    ENDDO
                 ELSEIF ( intermediate_timestep_count < &
                          intermediate_timestep_count_max )  THEN
-                   DO  k = nzb_s_inner(j,i)+1, nzt
-                      te_m(k,j,i) = -9.5625_wp * tend(k,j,i) + &
-                                     5.3125_wp * te_m(k,j,i)
+                   DO  k = nzb+1, nzt
+                      te_m(k,j,i) =   -9.5625_wp * tend(k,j,i) +               &
+                                       5.3125_wp * te_m(k,j,i)
                    ENDDO
                 ENDIF
@@ -1064,4 +1167,7 @@
     ENDDO
     !$OMP END PARALLEL
+
+
+
 
     CALL cpu_log( log_point(32), 'all progn.equations', 'stop' )
@@ -1150,8 +1256,12 @@
     DO  i = nxlu, nxr
        DO  j = nys, nyn
-          DO  k = nzb_u_inner(j,i)+1, nzt
-             u_p(k,j,i) = u(k,j,i) + dt_3d * ( tsc(2) * tend(k,j,i) +          &
-                                               tsc(3) * tu_m(k,j,i) )          &
-                                   - tsc(5) * rdf(k) * ( u(k,j,i) - u_init(k) )
+          DO  k = nzb+1, nzt
+             u_p(k,j,i) = u(k,j,i) + ( dt_3d * ( tsc(2) * tend(k,j,i) +          &
+                                                 tsc(3) * tu_m(k,j,i) )          &
+                                               - tsc(5) * rdf(k) *               &
+                                                        ( u(k,j,i) - u_init(k) ) &
+                                     ) * MERGE( 1.0_wp, 0.0_wp,                  &
+                                                 BTEST( wall_flags_0(k,j,i), 1 ) &
+                                              )
           ENDDO
        ENDDO
@@ -1164,5 +1274,5 @@
           DO  i = nxlu, nxr
              DO  j = nys, nyn
-                DO  k = nzb_u_inner(j,i)+1, nzt
+                DO  k = nzb+1, nzt
                    tu_m(k,j,i) = tend(k,j,i)
                 ENDDO
@@ -1173,6 +1283,7 @@
           DO  i = nxlu, nxr
              DO  j = nys, nyn
-                DO  k = nzb_u_inner(j,i)+1, nzt
-                   tu_m(k,j,i) = -9.5625_wp * tend(k,j,i) + 5.3125_wp * tu_m(k,j,i)
+                DO  k = nzb+1, nzt
+                   tu_m(k,j,i) =    -9.5625_wp * tend(k,j,i)                   &
+                                   + 5.3125_wp * tu_m(k,j,i)
                 ENDDO
              ENDDO
